From 2a6bddf2b9bcb55c41767aa0ed15c84c2a8f603c Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Feb 09 2017 15:58:10 +0000
Subject: [PATCH 717/1001] Convert the fedmsgstats widget


---

diff --git a/hubs/widgets/fedmsgstats/__init__.py b/hubs/widgets/fedmsgstats/__init__.py
new file mode 100644
index 0000000..b31ae11
--- /dev/null
+++ b/hubs/widgets/fedmsgstats/__init__.py
@@ -0,0 +1,76 @@
+from __future__ import unicode_literals
+
+import flask
+import fedmsg.config
+import fedmsg.meta
+import requests
+
+from hubs import validators
+from hubs.utils import commas
+from hubs.widgets.base import Widget, WidgetView
+from hubs.widgets.caching import CachedFunction
+from hubs.widgets.chrome import panel
+
+fedmsg_config = fedmsg.config.load_config()
+
+
+class FedmsgStats(Widget):
+
+    name = "fedmsgstats"
+    position = "both"
+    arguments = [dict(
+        name="username",
+        label="Username",
+        default=None,
+        validator=validators.username,
+        help="A FAS username.",
+        )]
+
+
+class BaseView(WidgetView):
+
+    name = "root"
+    url_rules = ["/"]
+    template_name = "templates/fedmsgstats.html"
+    chrome = panel()
+
+    def get_context(self, instance, *args, **kwargs):
+        username = instance.config["username"]
+        context = dict(
+            username=username,
+            hub_subscribe_url=flask.url_for(
+                'hub_subscribe', hub=instance.hub.name),
+            hub_unsubscribe_url=flask.url_for(
+                'hub_unsubscribe', hub=instance.hub.name),
+        )
+        get_stats = GetStats(instance)
+        context.update(get_stats())
+        return context
+
+
+class GetStats(CachedFunction):
+
+    def execute(self):
+        username = self.instance.config["username"]
+        url = "https://apps.fedoraproject.org/datagrepper/raw?user={username}"
+        url = url.format(username=username)
+        response = requests.get(url)
+        fedmsgs = response.json()['total']
+        sub_list = []
+        for assoc in self.instance.hub.associations:
+            if assoc.user:
+                sub_list = [u.name for u in assoc.user.subscriptions]
+        subscribers = [u.username for u in self.instance.hub.subscribers]
+        return dict(
+            fedmsgs=fedmsgs,
+            fedmsgs_text=commas(fedmsgs),
+            subscribers=subscribers,
+            subscribed_to=sub_list,
+            subscribers_text=commas(len(subscribers)),
+            subscribed_text=commas(len(sub_list)),
+            )
+
+    def should_invalidate(self, message):
+        usernames = fedmsg.meta.msg2usernames(message, **fedmsg_config)
+        username = self.instance.config['username']
+        return username in usernames

